# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# about VEE.
INFO = { \
	"comments" : "For The Zealots of VIM & X Terminal.",
	"copyright" : "Copyright © 2005 Spike^ekipS",
	"name" : "VEE",
	"version" : "2.2-1",
}

import gtk, sys, os, time

DIR_PIXMAPS = "/usr/share/pixmaps/vee/"
DIR_LIBFILE = "/usr/lib/vee/"
DIR_LOCALE = "/usr/share/locale/"
DIR_DOC = "/usr/share/doc/vee/"
DIR_HELP = "/usr/share/gnome/help/vee/"

#-------------------------------------------------------------------
LIST_KEYBOARD_SHORTCUT = {
	# select next tab.
	# 다음 탭으로 이동
	"next-tab" : ("<Control>Page_Up" , "self.ac_next_tab "),
	# select previous tab
	# 이전 탭으로 이동
	"prev-tab" : ("<Control>Page_Down" , "self.ac_previous_tab"),

	# increase font size.
	# vim과 터미널에서 폰트 크기 늘임
	"increase-font" : ("<Control>equal" , "self.ac_font_increase "),

	# decrease font size.
	# vim과 터미널에서 폰트 크기 줄임
	"decrease-font" : ("<Control>minus" , "self.ac_font_decrease "),

	# open gvim as new tab
	# gvim을 새로운 탭으로 띄우기
	"insert-gvim" : ("<Control><Shift>G" , "self.ac_insert_gvim "),

	# open vim as new tab
	# vim을 새로운 탭으로 띄우기
	"insert-vim" : ("<Control><Shift>V" , "self.ac_insert_vim "),

	# open terminal as new tab
	# 터미널을 새로운 탭으로 띄우기
	"insert-terminal" : ("<Control><Shift>Z" , "self.ac_insert_terminal "),

	# open external command dialog
	# 외부명령어 입력창 띄우기
	"run-external-command-dialog" : \
		("<Control><Shift>C" , "self.ac_run_on_external_command"),

	# set focus in the external command text entry in toolbar
	# 외부명령어 입력란에 포커스 이동하기
	"focus-external-command-entry" : \
		("<Control><Shift>L" , "self.ac_focus_on_external_command"),

	# open file selection dialog
	# 파일 열기
	"fileselect-dialog" : ("<Alt><Shift>F" , "self.ac_fileSelectionDialog "),

	# quit vee
	# 프로그램 종료
	#"mainwindow-quit" : ("<Control>Q" , "gtk.main_quit"),
	"mainwindow-quit" : ("<Control>Q" , "self.on_quit_all"),

	# select tab
	# 숫자키와 함께 사용할 탭 이동 키
	"modifier-switch-tab" : ("<Alt>%d", "self.ac_change_nth_tab"),

	# show/hide bookmark panel
	# 북마크 패널을 보이고 감추는 키
	"toggle-bookmark-panel" : ("<Ctrl><Alt>b", "self.ac_toggle_bookmark"),

	# show tab list
	# 탭 목록을 보여주는 키.
	"show-tab-list" : ("<Shift><Alt>l", "self.ac_show_tab_list"),

}

# Keyboard shorcut
KEYBOARD_SHORTCUT_GLOBAL = ( \
	"focus-external-command-entry",
	"toggle-bookmark-panel",
	"show-tab-list",
	"run-external-command-dialog",
)

KEYBOARD_SHORTCUT_WHEN_HIDE_MENUBAR = ( \
	"next-tab",
	"prev-tab",
	"increase-font",
	"decrease-font",
	"insert-gvim",
	"insert-vim",
	"insert-terminal",
	"fileselect-dialog",
	"mainwindow-quit",
	"focus-external-command-entry",
)

#-------------------------------------------------------------------
# D&D
DND_TARGET_COLOR = 100
DND_TARGET_BGIMAGE = 101
DND_TARGET_RESET_BG = 102
DND_TARGET_URI_LIST = 103
DND_TARGET_MOZ_URL = 104
DND_TARGET_UTF8_STRING = 105
DND_TARGET_COMPOUND_TEXT = 106
DND_TARGET_TEXT_PLAIN = 107
DND_TARGET_STRING = 108
DND_TARGET_TEXT_PLAIN = 109
DND_TARGET_TEXT = 110

# drag and drop target tables, it from terminal-screen.c in
# gnome-terminal.
DND_TARGET_TABLE = [
	( "application/x-color", 0, DND_TARGET_COLOR ),
	( "property/bgimage",    0, DND_TARGET_BGIMAGE ),
	( "x-special/gnome-reset-background", 0, DND_TARGET_RESET_BG ),
	( "text/uri-list",  0, DND_TARGET_URI_LIST ),
	( "text/x-moz-url",  0, DND_TARGET_MOZ_URL ),
	( "UTF8_STRING", 0, DND_TARGET_UTF8_STRING ),
	( "COMPOUND_TEXT", 0, DND_TARGET_COMPOUND_TEXT ),
	( "TEXT", 0, DND_TARGET_TEXT ),
	( "STRING",     0, DND_TARGET_STRING ),
	( "text/plain", 0, DND_TARGET_TEXT_PLAIN )
]

#-------------------------------------------------------------------
# GConf
# GLOBAL configuration values.
GLOBAL_FONT_SYSTEM_DEFAULT		= "/desktop/gnome/interface/monospace_font_name"

# LOCAL configuration values.
LOCAL_ROOT									=	"/apps/vee/"
SCHEMA_ROOT									=	"/schemas/apps/vee/"
SCHEMA_FILE									=	\
	os.path.join(DIR_LIBFILE, "vee.schema")

SCHEMA = {
	"use-system-default-font" : {
		"key" : LOCAL_ROOT + "use_system_default_font",
		"schema" : SCHEMA_ROOT + "use_system_default_font",
		"type" : "bool",
		"default" : True,
	},

	"font-vim" : {
		"key" : LOCAL_ROOT + "vim_font",
		"schema" : SCHEMA_ROOT + "vim_font",
		"type" : "string",
		"default" : "Monospace 16",
	},

	"font-terminal" : {
		"key" : LOCAL_ROOT + "terminal_font",
		"schema" : SCHEMA_ROOT + "terminal_font",
		"type" : "string",
		"default" : "Monospace 16",
	},

	"show-menubar" : {
		"key" : LOCAL_ROOT + "show_menubar",
		"schema" : SCHEMA_ROOT + "show_menubar",
		"type" : "bool",
		"default" : True,
	},

	"show-toolbar" : {
		"key" : LOCAL_ROOT + "show_toolbar",
		"schema" : SCHEMA_ROOT + "show_toolbar",
		"type" : "bool",
		"default" : True,
	},

	"show-statusbar" : {
		"key" : LOCAL_ROOT + "show_statusbar",
		"schema" : SCHEMA_ROOT + "show_statusbar",
		"type" : "bool",
		"default" : True,
	},

	"show-bookmark" : {
		"key" : LOCAL_ROOT + "show_bookmark",
		"schema" : SCHEMA_ROOT + "show_bookmark",
		"type" : "bool",
		"default" : True,
	},

	"command-gvim" : {
		"key" : LOCAL_ROOT + "gvim_command",
		"schema" : SCHEMA_ROOT + "gvim_command",
		"type" : "string",
		"default" : "gvim",
	},

	"command-vim" : {
		"key" : LOCAL_ROOT + "vim_command",
		"schema" : SCHEMA_ROOT + "vim_command",
		"type" : "string",
		"default" : "vim",
	},

	"command-terminal" : {
		"key" : LOCAL_ROOT + "terminal_command",
		"schema" : SCHEMA_ROOT + "terminal_command",
		"type" : "string",
		"default" : "bash",
	},

	"color-foreground" : {
		"key" : LOCAL_ROOT + "foreground_color",
		"schema" : SCHEMA_ROOT + "foreground_color",
		"type" : "int_list",
		"default" : [65535,65535,65535,0],
	},

	"color-background" : {
		"key" : LOCAL_ROOT + "background_color",
		"schema" : SCHEMA_ROOT + "background_color",
		"type" : "int_list",
		"default" : [0,0,0,0],
	},

	"latest-window-geometry" : {
		"key" : LOCAL_ROOT + "latest_window_geometry",
		"schema" : SCHEMA_ROOT + "latest_window_geometry",
		"type" : "string",
		"default" : "700,800,10,10",
	},

	"max-scrollline" : {
		"key" : LOCAL_ROOT + "max_scrollline",
		"schema" : SCHEMA_ROOT + "max_scrollline",
		"type" : "int",
		"default" : 100,
	},

	# filename to insert as new tab in console command.
	"filename-to-insert-as-new-tab-in-vim" : {
		"key" : LOCAL_ROOT + "filename_to_insert_as_new_tab_in_vim",
		"schema" : SCHEMA_ROOT + "filename_to_insert_as_new_tab_in_vim",
		"type" : "string",
		"default" : "",
	},

	"filename-to-insert-as-new-tab-in-gvim" : {
		"key" : LOCAL_ROOT + "filename_to_insert_as_new_tab_in_gvim",
		"schema" : SCHEMA_ROOT + "filename_to_insert_as_new_tab_in_gvim",
		"type" : "string",
		"default" : "",
	},

	"last-directory-path" : {
		"key" : LOCAL_ROOT + "last_directory_path",
		"schema" : SCHEMA_ROOT + "last_directory_path",
		"type" : "string",
		"default" : "/",
	},

	"last-directory-path-in-fileselectdialog" : {
		"key" : LOCAL_ROOT + "last_directory_path_in_fileselectdialog",
		"schema" : SCHEMA_ROOT + "last_directory_path_in_fileselectdialog",
		"type" : "string",
		"default" : "/",
	},

	"bookmarks" : {
		"key" : LOCAL_ROOT + "bookmarks",
		"schema" : SCHEMA_ROOT + "bookmarks",
		"type" : "string",
		"default" : "",
	},

	"external-command-list" : {
		"key" : LOCAL_ROOT + "external_command_list",
		"schema" : SCHEMA_ROOT + "external_command_list",
		"type" : "string",
		"default" : "",
	},

	"color-foreground" : {
		"key" : LOCAL_ROOT + "color_foreground",
		"schema" : SCHEMA_ROOT + "color_foreground",
		"type" : "string",
		"default" : "",
	},

	"color-background" : {
		"key" : LOCAL_ROOT + "color_background",
		"schema" : SCHEMA_ROOT + "color_background",
		"type" : "string",
		"default" : "",
	},

	"color-dim" : {
		"key" : LOCAL_ROOT + "color_dim",
		"schema" : SCHEMA_ROOT + "color_dim",
		"type" : "string",
		"default" : "",
	},

	"color-highlight" : {
		"key" : LOCAL_ROOT + "color_highlight",
		"schema" : SCHEMA_ROOT + "color_highlight",
		"type" : "string",
		"default" : "",
	},

	"color-cursor" : {
		"key" : LOCAL_ROOT + "color_cursor",
		"schema" : SCHEMA_ROOT + "color_cursor",
		"type" : "string",
		"default" : "",
	},

	"recent-opened-files" : {
		"key" : LOCAL_ROOT + "recent_opened_files",
		"schema" : SCHEMA_ROOT + "recent_opened_files",
		"type" : "string",
		"default" : "",
	},

	"recent-opened-directories" : {
		"key" : LOCAL_ROOT + "recent_opened_directories",
		"schema" : SCHEMA_ROOT + "recent_opened_directories",
		"type" : "string",
		"default" : "",
	},

	"tab-position" : {
		"key" : LOCAL_ROOT + "tab_position",
		"schema" : SCHEMA_ROOT + "tab_position",
		"type" : "string",
		"default" : "",
	},

	"enable-screensaver" : {
		"key" : LOCAL_ROOT + "enable_screensaver",
		"schema" : SCHEMA_ROOT + "enable_screensaver",
		"type" : "bool",
		"default" : False,
	},

	"timeout-screensaver" : {
		"key" : LOCAL_ROOT + "timeout_screensaver",
		"schema" : SCHEMA_ROOT + "timeout_screensaver",
		"type" : "int",
		"default" : 60000,
	},

	"use-vim" : {
		"key" : LOCAL_ROOT + "use_vim",
		"schema" : SCHEMA_ROOT + "use_vim",
		"type" : "bool",
		"default" : True,
	},

	"use-gvim" : {
		"key" : LOCAL_ROOT + "use_gvim",
		"schema" : SCHEMA_ROOT + "use_gvim",
		"type" : "bool",
		"default" : True,
	},

	"use-terminal" : {
		"key" : LOCAL_ROOT + "use_terminal",
		"schema" : SCHEMA_ROOT + "use_terminal",
		"type" : "bool",
		"default" : True,
	},

}

# the number of characters in label.
LABEL_LENGTH = 20

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Conf.py"


