#!/usr/bin/env python
# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import i18n

_ = i18n.gettext()

try :
	import sys, os, time
	import xmlrpclib
	import gconf
	import Options, GConf, Conf
except :
	raise ImportError, \
_("""This program requires these modules,
  - sys
  - os
  - gconf
  - time
  - xmlrpclib and,
  - vee modulees.

And you need to install python-gnome2 and pygtk and GTKv2.""")

# parse command-line argument.
__parser = Options.VEET()
(__OPTIONS, __ARGS) = __parser.parse_args()

if len(__ARGS) < 1 :
	print _("(WW) filename must be given.")
	__parser.print_help()
	print ""
	sys.exit(1)

# check whether filename is valid or not.
__files = list()
for i in __ARGS :
	__files.append(os.path.abspath(i))

__filenames = [time.time()] + __files

# check whether the UID environment variable exists or not.
__uid = os.getenv("UID_VEE")

if __uid :
	__data = (tuple(__filenames),) + (__uid, )
else :
	__data = (tuple(__filenames),)

data = xmlrpclib.dumps(__data)

GConf.verify()

GCONF_CLIENT = GConf.Client()
GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

if __OPTIONS.ARG_AS_GVIM :
	__key = "filename-to-insert-as-new-tab-in-gvim"
elif __OPTIONS.ARG_AS_VIM :
	__key = "filename-to-insert-as-new-tab-in-vim"

GCONF_CLIENT.set_value_by_conf(__key, data)

sys.exit(0)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "veet.py"


